﻿namespace Library
{
    /// <summary>
    /// Konstans értéket reprezentáló operandus
    /// </summary>
    public class ConstantOperand : Operand
    {
        /// <summary>
        /// A konstans értéke
        /// </summary>
        public byte Value { get; }

        /// <summary>
        /// Létrehoz egy új példányt az osztályból
        /// </summary>
        /// <param name="value">A reprezentált érték</param>
        public ConstantOperand(byte value)
        {
            this.Value = value;
        }

        /// <summary>
        /// Kiírja az operandust
        /// </summary>
        /// <returns>Az operandus hexadecimálisan, két helyiértékre formázva</returns>
        public override string Write() => this.Value.ToString("X2");
    }
}
