﻿namespace Library
{
    /// <summary>
    /// Memóriacímet reprezentáló paraméter
    /// </summary>
    public class MemoryAddressOperand : Operand
    {
        /// <summary>
        /// A memóriacím
        /// </summary>
        public int Address { get; }

        /// <summary>
        /// Létrehoz egy új objektumot
        /// </summary>
        /// <param name="address">A memóriacím</param>
        public MemoryAddressOperand(int address)
        {
            this.Address = address;
        }

        /// <summary>
        /// 4 helyiértékkel kiírja a memóriacímet hexadecimálisan
        /// </summary>
        /// <returns>A memóriacím 4 hexadecimális helyiértékre formázva</returns>
        public override string Write() => this.Address.ToString("X4");
    }
}
