﻿namespace Library
{
    /// <summary>
    /// Operandus nélküli operátort reprezentál
    /// </summary>
    public abstract class NoOperandOperator : Operator
    {
        /// <summary>
        /// Létrehoz egy új operátorpéldányt
        /// </summary>
        /// <param name="opCode">Az operátor kódja</param>
        public NoOperandOperator(byte opCode) : base(opCode) { }

        /// <summary>
        /// Kiírja az operátor paramétereit a bájtkód formátumnak megfelelően
        /// </summary>
        /// <returns>Mivel ennek a típusnak nincsenek paraméterei, üres stringet ad vissza</returns>
        protected override string WriteParameters() => string.Empty;        
    }
}
