﻿namespace Library
{
    /// <summary>
    /// Egyoperandusú operátort reprezentáló osztály
    /// </summary>
    public abstract class OneOperandOperator : Operator
    {
        /// <summary>
        /// LÉtrehoz egy új operátorpéldányt
        /// </summary>
        /// <param name="opCode">A művelet bájtkódja</param>
        public OneOperandOperator(byte opCode) : base(opCode) { }

        /// <summary>
        /// Az egyetlen operandus (ezekben az esetekben ez mindig memóriacím)
        /// </summary>
        public MemoryAddressOperand Operand { get; set; }

        /// <summary>
        /// Kiírja az egyetlen operandust a bájtkódnak megfelelően
        /// </summary>
        /// <returns>A paraméter a bájtkódnak megfelelően</returns>
        protected override string WriteParameters() => Operand.Write();
    }
}
