﻿namespace Library
{
    public class AddCOperator : TwoOperandOperator
    {
        public AddCOperator() : base(3) { }

        /// <summary>
        /// Az első paraméter által reprezentált címen lévő értékhez hozzáadja a konstans címet
        /// </summary>
        /// <param name="emulatorMemory"></param>
        public override void Execute(EmulatorMemory emulatorMemory)
        {
            var op1 = (MemoryAddressOperand)this.Op1;
            var op2 = (ConstantOperand)this.Op2;
            var result = emulatorMemory[op1] + op2.Value; 
            if (result > byte.MaxValue) // overflow kezelés manuálisan
            {
                emulatorMemory.LastOperationOverflow = true;
            }
            result = result % byte.MaxValue;
            emulatorMemory[op1] = (byte)result;
            emulatorMemory.LastResult = (byte)result;
        }
    }
}
