﻿namespace Library
{
    public class AddOperator : TwoOperandOperator
    {
        public AddOperator() : base(2) { }

        /// <summary>
        /// Összeadja a két operátor által mutatott címen lévő értéket és az első helyre visszarakja
        /// </summary>
        /// <param name="emulatorMemory"></param>
        public override void Execute(EmulatorMemory emulatorMemory)
        {

            var op1 = (MemoryAddressOperand)this.Op1;
            var op2 = (MemoryAddressOperand)this.Op2;
            var result = emulatorMemory[op1] + emulatorMemory[op2]; // Az eredmény int32, így nem lesz overflow
            if (result > byte.MaxValue) // overflow kezelés manuálisan
            {
                emulatorMemory.LastOperationOverflow = true;
            }
            result = result % byte.MaxValue;
            emulatorMemory[op1] = (byte)result;
            emulatorMemory.LastResult = (byte)result;
        }
    }
}
