﻿namespace Library
{
    public class SubCOperator : TwoOperandOperator
    {
        public SubCOperator() : base(5) { }

        /// <summary>
        /// Kivonja az első paraméter címen lévő értékből a második paraméter értékét és visszarakja az első helyre
        /// </summary>
        /// <param name="emulatorMemory"></param>
        public override void Execute(EmulatorMemory emulatorMemory)
        {
            var op1 = (MemoryAddressOperand)this.Op1;
            var op2 = (ConstantOperand)this.Op2;
            var result = emulatorMemory[op1] - op2.Value;
            if (result > byte.MaxValue)
            {
                emulatorMemory.LastOperationOverflow = true;
                result = result % byte.MaxValue;
            }
            if (result < 0)
            {
                emulatorMemory.LastOperationOverflow = true;
                result = 256 + result;
            }
            emulatorMemory[op1] = (byte)result;
            emulatorMemory.LastResult = (byte)result;
        }
    }
}
