﻿namespace Library
{
    public class SubOperator : TwoOperandOperator
    {
        public SubOperator() : base(4) { }

        /// <summary>
        /// Kivonja a két memóriacímen lévő értéket és az első helyre rakja az eredményt
        /// </summary>
        /// <param name="emulatorMemory"></param>
        public override void Execute(EmulatorMemory emulatorMemory)
        {
            var op1 = (MemoryAddressOperand)this.Op1;
            var op2 = (MemoryAddressOperand)this.Op2;
            var result = emulatorMemory[op1] - emulatorMemory[op2];
            if (result > byte.MaxValue) // overflow kezelés manuálisan
            {
                emulatorMemory.LastOperationOverflow = true;
                result = result % byte.MaxValue;
            }
            if (result < 0)
            {
                emulatorMemory.LastOperationOverflow = true;
                result = 256 + result;
            }
            emulatorMemory[op1] = (byte)result;
            emulatorMemory.LastResult = (byte)result;
        }
    }
}
