﻿namespace Library
{
    /// <summary>
    /// Két operandusú művelet alaposztálya
    /// </summary>
    public abstract class TwoOperandOperator : Operator
    {
        /// <summary>
        /// Létrehoz egy kétoperandusú művelet példányt
        /// </summary>
        /// <param name="opCode">A művelet kódja</param>
        public TwoOperandOperator(byte opCode) : base(opCode) { }

        /// <summary>
        /// Az egyik operandus
        /// </summary>
        public Operand Op1 { get; set; }

        /// <summary>
        /// A másik operandus
        /// </summary>
        public Operand Op2 { get; set; }

        /// <summary>
        /// Paraméterek kiírása: Kiírjuk a két paramétert
        /// </summary>
        /// <returns>Visszaadja a paramétereket string formában a bájtkódba beleírható formában</returns>
        protected override string WriteParameters() => $"{Op1.Write()}{Op2.Write()}";

    }
}
