﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Emulator
{
    class Program
    {
        static void Main(string[] args)
        {
            // Ide kerül a billentyűzetről törénő beolvasás és ez alapján az emulator vezérlése
            Emulator emulator = new Emulator();
            while (true)
            {
                Console.WriteLine("Graphic memory contents: ");
                emulator.DisplayDisplay();
                string option = Console.ReadLine();
                Console.Clear();
                if (option.ToUpper().StartsWith("L"))
                {
                    var ar = option.Split(' ');
                    if (ar.Length != 2 || ar[0].ToUpper() != "L")
                    {
                        Console.WriteLine("Unknown command");
                    }
                    else
                    {
                        if (File.Exists(ar[1]))
                        {
                            emulator.Load(ar[1]);
                        }
                        else
                        {
                            Console.WriteLine("Spcified file does not exist");
                        }
                    }
                }
                else if (option.ToUpper().StartsWith("M"))
                {
                    var ar = option.Split(' ');
                    if (ar.Length != 2 || ar[0] != "M")
                    {
                        Console.WriteLine("Unknown command");
                    }
                    else
                    {
                        if (int.TryParse(ar[1], NumberStyles.HexNumber, CultureInfo.InvariantCulture, out int address))
                        {
                            emulator.Memory(address);
                        }
                        else
                        {
                            Console.WriteLine("Invalid address");
                        }
                    }
                }
                else if (option.ToUpper() == "S")
                {
                    emulator.Step();
                }
                else if (option.ToUpper() == "R")
                {
                    emulator.Run();
                }
                else if (option.ToUpper() == "Q")
                {
                    break;
                }
                else
                {
                    Console.WriteLine("Unknown command");
                }
            }
        }
    }
}
